// a negative edge triggered D flip flop with asynchronous reset.
module edge_dff(input d, clk, reset, output reg q, qbar);
always @(negedge clk) begin
     q = d; qbar = ~d;
end
always @(reset)    // override the regular assignments to q and qbar.
     if (reset) begin 
          assign q = 1'b0;
          assign qbar = 1'b1;
    end else begin // end the effect of assign
          deassign q;       
          deassign qbar; 
    end 
endmodule 

